package my.project.seam;

import my.project.model.City;
import my.project.model.Person;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;
import javax.persistence.EntityManager;
import java.util.Date;
import java.util.List;

/**
 * User: schullto
 * Date: 1/16/13
 * Time: 5:33 PM
 */
@Named
@RequestScoped
public class CityBean {
    @Inject
    EntityManager hem;

    public List<City> getCities() {
        List retList = hem.createQuery("select object(c) from City c").getResultList();
        System.out.println("retList = " + retList);
        return retList;
    }

    public void createNewCity() {
        City city = new City();
        city.setName("newCity-" + new Date());
        hem.persist(city);
    }

    public void createNewPerson(City city) {
        Person p = new Person();
        p.setFirstName("newPerson-" + new Date());
        p.setCity(city);
        hem.persist(p);
        city.getPersons().add(p);
        System.out.println("p = " + p);
    }

    public void editPerson(Person person) {
        person.setFirstName(person.getFirstName() + "x");
        person = hem.merge(person);
    }
}
